      CHARACTER*12 ANS
	INTEGER*4	SYS$ASSIGN,SYS$QIOW
      INTEGER SCHAR(2),IOSB(2)
      CHARACTER*6 TAPE
      INTEGER*2 TCHAN
C  "INCLUDE" FILE FOR I/O DEFINITIONS
	PARAMETER IO$_READLBLK   = '0021'X, IO$_READVBLK   = '0031'X
	PARAMETER IO$_REWIND     = '0024'X, IO$_REWINDOFF  = '0022'X
	PARAMETER IO$_SENSEMODE  = '0027'X
	PARAMETER IO$_SETCHAR    = '001A'X, IO$_SETMODE    = '0023'X
	PARAMETER IO$_SKIPFILE   = '0025'X, IO$_SKIPRECORD = '0026'X
	PARAMETER IO$_WRITELBLK  = '0020'X, IO$_WRITEVBLK  = '0030'X
	PARAMETER IO$_WRITEOF    = '0028'X
	PARAMETER IO$M_INHRETRY  = '8000'X, IO$M_NOWAIT    = '0007'X
	PARAMETER MT$M_PARITY    = '0008'X
	PARAMETER MT$M_DENSITY   = '1F00'X, MT$V_DENSITY   = '0008'X
	PARAMETER MT$K_PE_1600   = '0004'X, MT$K_NRZI_800  = '0003'X
	PARAMETER MT$M_BOT       ='10000'X, MT$M_EOF       ='20000'X
	PARAMETER SS$_CTRLERR    = '0054'X, SS$_DRVERR     = '008C'X
	PARAMETER SS$_DATACHECK  = '005C'X, SS$_DATAOVERUN = '0838'X
	PARAMETER SS$_ENDOFFILE  = '0870'X, SS$_ENDOFTAPE  = '0878'X
	PARAMETER SS$_PARITY     = '01F4'X
      CHARACTER*16000 BUF
      CHARACTER*80 VOL,LAB1,LAB2
      CHARACTER*6000 REC
      DATA VOL /'VOL1      '/
      DATA LAB1,LAB2 /' ',' '/
      CHARACTER VOLSER*6
      CHARACTER DSN*17,FILE*40
C
C
C
      DIMENSION ATOE(0:255)
      BYTE ATOE
      DATA ATOE /"0,"1,"2,"3,"4,"5,"6,"7,"10,"11,
     1  "12,"13,"14,"15,"16,"17,"20,"21,"22,"23,"24,"25,"26,"27,"30,
     2 "31,"32,"33,"34,"35,"36,"37,
     3  "100,"132,"177,"173,"133,"154,"120,"175,"115,"135,"134,"116,
     4  "153,"140,"113,"141,"360,"361,"362,"363,"364,"365,"366,"367,
     5  "370,"371,"174,"136,"114,"176,"156,"157,"174,"301,"302,"303,
     6  "304,"305,"306,"307,"310,"311,"321,"322,"323,"324,"325,"326,
     7  "327,"330,"331,"342,"343,"344,"345,"346,"347,"350,"351,"255,
     8  "340,"275,"152,"155,"171,"201,"202,"203,"204,"205,"206,"207,
     9  "210,"211,"221,"222,"223,"224,"225,"226,"227,"230,"231,"242,
     A  "243,"244,"245,"246,"247,"250,"251,"213,"117,"233,"137,
     B  129*'@'/
C
C
C
C          A GENERAL COPY PACKAGE FOR GENERATING IBM
C          FIXED BLOCK TAPES IN EBCDIC
C             THE TAPES MAY BE LABELED OR UNLABELED
C          THE LAST BLOCK OF A FILE MAY BE SHORT
C           THE END OF TAPE IS NOTED BY TWO CONSEQUTIVE TAPE MARKS
C
C       SET UP TAPE DRIVE
C
      OPEN(UNIT=5,NAME='SYS$INPUT',RECORDSIZE=255)
      OPEN(UNIT=6,NAME='SYS$OUTPUT',RECORDSIZE=255)
C
C       NOW PROMPT USER FOR TAPE DRIVE
C
10    WRITE(6,12000)
12000 FORMAT('$ENTER TAPE DRIVE :')
      READ(5,11000,ERR=10)TAPE
11000 FORMAT(A)
      ISTAT = SYS$ASSIGN(TAPE,TCHAN,,)
      IF (.NOT. ISTAT) GOTO 9000
C       NOW THAT A CHANNEL HAS BEEN ASSIGNED SET CHARACTERISTIC
C       FOR NOW CHARACTERISTICS ARE 1600 BPI 9TRK PE
      SCHAR(2) = 0
      SCHAR(2) = MT$K_PE_1600*2**MT$V_DENSITY
      ISTAT=SYS$QIOW (,%VAL(TCHAN),%VAL(IO$_SETMODE),IOSB,,,SCHAR,,,,,)
C      TYPE *,'  Q SETMODE'
C
C        NOW ASSURE LOAD POINT
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_REWIND),IOSB,,,,,,,,)
C      TYPE *,' Q REWIND'
C
CC        NOW PROMPT USER FOR TYPE OF TAPE
20    WRITE(6,12005)
12005 FORMAT(1X,'ENTER VOLUME NAME (6 CHAR) FOR LABELED TAPE',/
     1  '$       OR "NONE" FOR NONLABELED TAPE :')
      READ(5,11000,ERR=20)VOLSER
C      NOW BRANCH AROUND LABEL ACTIVITY FOR NONLABELED
C
      IF(VOLSER.EQ.'NONE  ') GOTO 1000
C
C        NOW BUILD VOL1 LABEL
C
      VOL(5:10) = VOLSER
C
C        NOW WRITE THE LABEL
C
      BUF(1:80) = VOL
C      CALL TRANSLATE(BUF,80)
      CALL VAX2IBM(80,%REF(BUF))
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITELBLK),IOSB,,,
     1   %REF(BUF),%VAL(80),,,,)
C       TYPE *,VOL
C
C        NOW FIND OUT DETAILS ABOUT SOURCE FILE
C
1000  WRITE(6,12010)
12010 FORMAT('$ENTER FILE NAME TO COPY OR "STOP" :')
      JBLOCK = 0
      READ(5,11000,ERR=1000)FILE
      IF(FILE.EQ.'STOP') GOTO 8000
      IF(FILE.EQ.' ') GOTO 1000
C
C      NOW TRY AND OPEN FILE IF ERROR NOTIFY AND TRY AGAIN
C
      OPEN(UNIT=1,NAME=FILE,TYPE='OLD',READONLY,SHARED,ERR=1010)
      GOTO 1030
C       OPEN ERROR
C
1010  WRITE(6,12015)FILE
12015 FORMAT(1X,'UNABLE TO OPEN FILE :',A)
      GOTO 1000
C       FILE OPEN   NOW TRY AND GET DETAILS ABOUT FILE
C       QUESTIONS WILL BE ORIENTED ABOUT LABELS OR NO LABELS
C
1030  WRITE(6,12020)
12020 FORMAT('$ENTER RECORD SIZE :')
      READ(5,*,ERR=1030)IREC
C
1035  WRITE(6,12035)
12035 FORMAT('$ENTER NUMBER OF RECORDS PER BLOCK :')
      READ(5,*,ERR=1035)NPB
      IBLOCK = IREC*NPB
      IF(IBLOCK.LT.24000) GOTO 1040
C
C     TOO BIG LETS TRY AGAIN
C
      WRITE(6,12040)IBLOCK
12040 FORMAT(1X,'BLOCK SIZE EXCEEDS 24000 -- TRY AGAIN')
      GOTO 1030
C
C       IF LABELED ASK IF FILE CONTAINS ANSII CARRIAGE CONTROLS
C
1040  IF(VOLSER.EQ.'NONE  ') GOTO 2000
C
C      LABELED DO LABEL STUFF
1050  WRITE(6,12045)
12045 FORMAT('$DOES FILE CONTAIN  FORTRAN LINE PRINTER CONTROLS Y/N :')
      READ(5,11000,ERR=1050)ANS
      IF(ANS(1:1).EQ.'N') GOTO 1060
      IF(ANS(1:1).EQ.'Y') GOTO 1060
      GOTO 1050
C
C
C     BUILD LABELS
1060  LAB1 = 'HDR1       '
      LAB2 = 'HDR2       '
C        ASK FOR DESTINATION FILE
C
1065  WRITE(6,12050)
12050 FORMAT('$ENTER DESTINATION DATASET NAME :')
      READ(5,11000,ERR=1065)DSN
       IF(DSN.EQ.' ')GOTO 1065
      LAB1(5:21) = DSN
      ISEQ = ISEQ + 1
      JSEQ = ISEQ+10000
      ENCODE(5,11005,BUF(:5))JSEQ
11005 FORMAT(I5)
      LAB1(32:35) = BUF(2:5)
      LAB1(49:53) = '00000'
      LAB1(55:60) = '000000'
      LAB2(5:5) = 'F'
      ENCODE(6,11006,BUF(:6))IBLOCK+100000
      LAB2(6:10) = BUF(2:6)
      ENCODE(6,11006,BUF(:6))IREC+100000
      LAB2(11:15) = BUF(2:6)
      LAB2(16:16) = '3'
      LAB2(17:17) = '0'
      IF(ANS(1:1).EQ.'Y') LAB2(37:37) = 'A'
      IF(IBLOCK.NE.IREC) LAB2(39:39) = 'B'
11006 FORMAT(I6)
C
C
C      NOW WRITE LABEL
      BUF(1:80) = LAB1
C      CALL TRANSLATE(BUF,80)
       CALL VAX2IBM(80,%REF(BUF))
C
C
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITELBLK),IOSB,,,
     1 %REF(BUF),%VAL(80),,,,)
C      TYPE *,LAB1
      BUF(1:80) = LAB2
C      CALL TRANSLATE(BUF,80)
       CALL VAX2IBM(80,%REF(BUF))
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITELBLK),IOSB,,,
     1 %REF(BUF),%VAL(80),,,,)
C      TYPE *,LAB2
C         NOW WRITE TAPEMARK
C
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITEOF),IOSB,,,,,,,,)
C      TYPE *,' Q EOF'
C
C         NOW READ RECORDS OFF 1 AND BUILD BUFFER
C
2000  CONTINUE
C
C         INITIALIZE FOR BUFFER
C
      IBUF = 0
C
C         NOW HAVE A READ LOOP TO BUILD BUFFER
C
      DO 2100 IBUF =1,IBLOCK,IREC
      JBUF = IBUF-1
2100  READ(1,11000,END=2300)BUF(IBUF:IBUF+IREC-1)
C
C       NOW WRITE BLOCK  AND UPDATE BLOCK COUNT
C
C      TYPE *,'  BLOCK= ',BUF(1:IBLOCK)
C      CALL TRANSLATE(BUF,IBLOCK)
      CALL VAX2IBM(IBLOCK,%REF(BUF))
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITELBLK),IOSB,,,
     1  %REF(BUF),%VAL(IBLOCK),,,,)
C
C       READ NEXT BLOCK
C
      JBLOCK = JBLOCK + 1
      GOTO 2000
C
C       EOF READ OUTPUT PARTIAL BLOCK IF THERE
C
2300  IF(JBUF.EQ.0) GOTO 2400
C      TYPE *,' LAST BLOCK',BUF(1:JBUF)
C      CALL TRANSLATE(BUF,JBUF)
       CALL VAX2IBM(JBUF,%REF(BUF))
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITELBLK),IOSB,,,
     1  %REF(BUF),%VAL(JBUF),,,,)
	JBLOCK = JBLOCK + 1
C
C       WRITE TAPEMARK AT END OF A FILE
2400  CONTINUE
      CLOSE(UNIT=1)
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITEOF),IOSB,,,,,,,,)
C      TYPE *,' Q EOF'
      IF(VOSER.EQ.'NONE  ') GOTO 1000
C
C        LABELED TAPE SO WRITE TRAILER LABELS
C
      LAB1(1:3) = 'EOF'
      LAB2(1:3) = 'EOF'
      ENCODE(7,11007,BUF(1:7))JBLOCK+1000000
11007 FORMAT(I7)
      LAB1(55:60) = BUF(2:7)
      BUF(1:80) = LAB1
C      CALL TRANSLATE(BUF,80)
       CALL VAX2IBM(80,%REF(BUF))
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITELBLK),IOSB,,,
     1  %REF(BUF),%VAL(80),,,,)
C       TYPE *,LAB1
      BUF(1:80) = LAB2
C      CALL TRANSLATE(BUF,80)
      CALL VAX2IBM(80,%REF(BUF))
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITELBLK),IOSB,,,
     1  %REF(BUF),%VAL(80),,,,)
C      TYPE *,LAB2
C
C          NOW WRITE TAPEMARK FOR END OF LABEL
C
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITEOF),IOSB,,,,,,,,)
CC      TYPE *,' Q EOF'
C
C          NOW GO BACK FOR NEXT FILE
C
      GOTO 1000
C
C          TERMINATE COPY OPERATION
C
8000  CONTINUE
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITEOF),IOSB,,,,,,,,)
C      TYPE *,' Q EOF  LAST ONES'
      ISTAT = SYS$QIOW(,%VAL(TCHAN),%VAL(IO$_WRITEOF),IOSB,,,,,,,,)
      GOTO 10000
C
C         FATAL ERROR
C
9000	TYPE *,'UNABLE TO ASSIGN TAPE CHANNEL  ISTAT=',ISTAT
10000 CONTINUE
      END
