$! THE FOLLOWING IS A PROCEDURE WHICH CAN BE INVOKED, TRANSPARENT TO THE
$! USER, TO ALLOW THE ACCESS OF REMOTE DIRECTORY INFORMATION.
$! ALTHOUGH DESIGNED FOR REMOTE RSX11M SYSTEMS, MODIFICATION FOR OTHER
$! TYPES OF REMOTE NODES SHOULD BE STRAIGHT FORWARD.
$!
$! USE OF THIS PROCEDURE REQUIRES THE DEFINITION OF SYSTEM LOGICAL NAMES
$! FOR THE REMOTE DEVICES WHICH INCLUDE THE NODE NAME.
$!
$!	EG: "$ ASSIGN/SYSTEM NODENAME::DP1: DP1:"
$!
$! FURTHER, THE FOLLOWING LINE SHOULD APPEAR IN SYSLOGIN.COM:
$!	"DIR:==@SYSCMD:DIRECTORY"
$!	(WHERE SYSCMD IS THE LOCATION OF THE FILE DIRECTORY.COM)
$!
$!		Mr. H. E. Chadwick
$!		Department 22810
$!		Western Electric Co., Inc.
$!		6200 East Broad Street
$!		Columbus, Ohio 43213
$!			614-868-2093
$!
$!
$! SET UP DEFAULTS
$!
$ COUNT=0
$ DEVICE_SPEC:=NL:
$!
$! WAS THERE A PARAMETER?
$!
$ IF P1.EQS."" THEN GOTO NORMAL_DIRECTORY_COMMAND
$!
$! IF THERE WAS NO COLON THEN MUST BE DIRECTED AT THE LOCAL SYSTEM.
$!
$ TRANSLATE:
$!
$ P1_LENGTH='F$LENGTH(P1)'
$ LOC_COLON='F$LOCATE(":",P1)'
$ IF LOC_COLON.EQ.'P1_LENGTH' THEN GOTO NORMAL_DIRECTORY_COMMAND
$!
$! IF THERE WAS A COLON WAS IT PART OF A DOUBLE COLON
$!
$ LOC_DUB_COLON='F$LOCATE("::",P1)'
$ IF LOC_COLON.EQ.'LOC_DUB_COLON' THEN GOTO GET_REMOTE_DEVICE_SPEC
$!
$! WE'VE GOT A VALID DEVICE NAME, SEE IF IT WILL TRANSLATE.
$!
$ DEVICE_SPEC:='F$EXTRACT(0,LOC_COLON,P1)'
$ DEVICE_TRANSLATION:='F$LOGICAL(DEVICE_SPEC)'
$ IF DEVICE_TRANSLATION.EQS."" THEN GOTO NORMAL_DIRECTORY_COMMAND
$ LOC_COLON='LOC_COLON'+1
$ FILE_SPEC_SEGMENT:='F$EXTRACT(LOC_COLON,P1_LENGTH,P1)'
$ IF LOC_COLON.EQ.'P1_LENGTH' THEN FILE_SPEC_SEGMENT:=""
$ P1:='DEVICE_TRANSLATION''FILE_SPEC_SEGMENT'
$ GOTO TRANSLATE
$!
$! OK, IT'S FOR A REMOTE NODE.  GET THE DEVICE SPEC.
$!
$ GET_REMOTE_DEVICE_SPEC:
$!
$ LOC_NODE_NAME_END=LOC_DUB_COLON+2
$ FILE_SPEC_SEGMENT:='F$EXTRACT(LOC_NODE_NAME_END,P1_LENGTH,P1)'
$ LOC_COLON='F$LOCATE(":",FILE_SPEC_SEGMENT)'
$ IF LOC_COLON.GE.'F$LENGTH(FILE_SPEC_SEGMENT)' THEN GOTO GET_REMOTE_DIRECTORY_SPEC
$ LOC_DEVICE_SPEC_END='LOC_COLON'+1
$ REMOTE_DEV:=='F$EXTRACT(LOC_NODE_NAME_END,LOC_DEVICE_SPEC_END,P1)
$!
$! NOW GET THE DIRECTORY SPEC.
$!
$ GET_REMOTE_DIRECTORY_SPEC:
$!
$ LOC_LFT_BRACKET='F$LOCATE("[",P1)'
$ IF LOC_LFT_BRACKET.EQ.'P1_LENGTH' THEN GOTO USE_DEFAULT_UFD
$ LOC_RT_BRACKET='F$LOCATE("]",P1)'
$ UFD_LENGTH='LOC_RT_BRACKET'-'LOC_LFT_BRACKET'+1
$ REMOTE_UFD:=='F$EXTRACT(LOC_LFT_BRACKET,UFD_LENGTH,P1)'
$!
$ USE_DEFAULT_UFD:
$!
$ OPEN/WRITE IND RSXDIR.COM
$ WRITE IND "PIP RSXDIR.DAT=''REMOTE_DEV'''REMOTE_UFD'/LI"
$ WRITE IND ".DELAY 10.S"
$ WRITE IND "PIP RSXDIR.COM;*/DE,RSXDIR.DAT;*"
$ CLOSE IND
$ IF "''F$MODE()'".NES."BATCH" THEN WRITE SYS$OUTPUT "NETWORK CALL BEING MADE"
$ ASSIGN/USER_MODE NL: SYS$OUTPUT
$ EDIT/NOLINES RSXDIR.COM
EB
$ COPY RSXDIR.COM NODNAME::[200,200]RSXDIR.COM;1
$ SUBMIT/REMOTE NODNAME::[200,200]RSXDIR
$ SET NOON
$ DELETE RSXDIR.COM.*
$ ASSIGN NL: SYS$ERROR:
$ WAIT_COUNT=12
$ IF "''DEVICE_SPEC'".EQS."MM0" THEN WAIT_COUNT=100
$ 10:
$ IF COUNT.EQ.5*(COUNT/5) THEN-
	IF "''F$MODE()'".NES."BATCH" THEN-
		WRITE SYS$OUTPUT "	WORKING..."
$ COUNT='COUNT'+1
$ WAIT 0:0:02
$ IF COUNT.GT.'WAIT_COUNT' THEN GOTO TRANSFER_ERROR
$ ASSIGN/USER NL: SYS$OUTPUT:
$ COPY NODNAME::[200,200]RSXDIR.DAT *
$ IF .NOT.$STATUS THEN GOTO 10
$ TYPE RSXDIR.DAT
$ DELETE RSXDIR.DAT.*
$ SET ON
$ DEASSIGN SYS$ERROR:
$ EXIT
$!
$ TRANSFER_ERROR:
$!
$ WRITE SYS$OUTPUT "TRANSFER OF DIRECTORY LIST FAILED"
$ EXIT
$!
$ NORMAL_DIRECTORY_COMMAND:
$!
$ DIRECTORY 'P1'
